#pragma once
#include <gtkmm/window.h>
#include <glibmm.h>
#include <gtkmm/builder.h>
#include <gtkmm/dropdown.h>
#include <gtkmm/entry.h>
#include <gtkmm/button.h>

namespace components {
    class PrefWindow : public Gtk::Window
    {
    public:
        PrefWindow(
            BaseObjectType* cobject,
            const Glib::RefPtr<Gtk::Builder>& refBuilder);

        static PrefWindow* create(Gtk::Window& parent);

    protected:
        Glib::RefPtr<Gtk::Builder> m_builder;
        Gtk::DropDown* m_quality_dropdown;
        Gtk::Entry* m_apikey_entry;
        Gtk::Button* m_cancel_btn;
        Gtk::Button* m_save_btn;

        // -- Обработчики событий --
        void onCancelClicked();
        void onSaveClicked();

        // Сохраняет настройки
        void saveConfig();
    };
}