#pragma once
#include <YoutubeApi/youtubeapi.hpp>
#include <Database/database.hpp>
#include <gtkmm/box.h>
#include <glibmm/ustring.h>
#include <fstream>
#include <iostream>
#include <string>

namespace core {
    // Возвращает объект видео по его Youtube id
    db::video getVideoByYTID(std::string yt_id);

    // Возвращает дочерний виджет для кнопок, которым нужны иконка с текстом
    Gtk::Box* getButtonContents(Glib::ustring text, std::string icon_name);

    // Возвращает строку формата yt-dl
    std::string getYTDLFormat(int height);

    class Settings {
    public:
        static void setConfigPath(std::string config_path);
        static void setApiKey(std::string api_key);
        static void setQuality(int quality);

        static std::string getConfigPath();
        static std::string getApiKey();
        static int getQuality();

        // Путь к файлу настроек
        static std::string s_config_path;
        
        // Ключ API
        static std::string s_api_key;

        // Качество воспроизводимых видео (240/360/480/720/1080p)
        static int s_quality;
    };
}
