#include "app.hpp"
#include "core.hpp"
#include <glibmm.h>
#include <curl/curl.h>
#include <Database/database.hpp>
#include <YoutubeApi/youtubeapi.hpp>
#include <iostream>
#include <fstream>
#include <nlohmann/json.hpp>

using json = nlohmann::json;

int main(int argc, char** argv) {
    // -- Локаль --
    std::locale::global(std::locale(""));

    // -- Получение данных из файла настроек --
    std::string config_path = Glib::build_filename(
        Glib::get_user_config_dir(),
        "ytmpv",
        "config.json");
    std::ifstream config_file(config_path);
    auto j_config = json::parse(config_file);
    config_file.close();

    // TODO
    std::string db_path = "/home/vad/Code/YTMPV/db.sqlite3";
    
    // -- Общая инициализация --
    curl_global_init(CURL_GLOBAL_ALL);
    db::databaseInit(db_path);
    db::createTables();
    ytapi::youtubeInit(j_config["apikey"]);

    // -- Запуск приложения --
    core::Settings::setConfigPath(config_path);
    core::Settings::setApiKey(j_config["apikey"]);
    core::Settings::setQuality(j_config["quality"]);
    auto app = components::App::create();
    return app->run(argc, argv);
}
